gc.sh: optimize darcs repositories
[girocco.git] / install.sh
blob4fbf48b76b4282be7263ddaec8e8c8075d8cea03
1 #!/bin/sh
2 # The Girocco installation script
3 # We will OVERWRITE basedir!
5 set -e
7 if [ -z "$MAKE" ]; then
8 echo "ERROR: MAKE not set" >&2
9 echo "Please run install.sh using 'make install'" >&2
10 echo "or set MAKE to the name of the GNU make executable" >&2
11 exit 1
14 # Run perl module checker
15 if [ ! -x toolbox/check-perl-modules.pl ]; then
16 echo "ERROR: missing toolbox/check-perl-modules.pl!" >&2
17 exit 1
19 toolbox/check-perl-modules.pl
21 # What Config should we use?
22 [ -n "$GIROCCO_CONF" ] || GIROCCO_CONF=Girocco::Config
23 echo "*** Initializing using $GIROCCO_CONF..."
25 # First run Girocco::Config consistency checks
26 perl -I. -M$GIROCCO_CONF -e ''
28 . ./shlib.sh
30 owngroup=""
31 [ -z "$cfg_owning_group" ] || owngroup=":$cfg_owning_group"
32 if [ -n "$cfg_httpspushurl" -a -z "$cfg_certsdir" ]; then
33 echo "ERROR: \$httpspushurl is set but \$certsdir is not!" >&2
34 echo "ERROR: perhaps you have an incorrect Config.pm?" >&2
35 exit 1
39 echo "*** Checking for compiled utilities..."
40 if [ ! -x src/can_user_push ]; then
41 echo "ERROR: src/can_user_push is not built! Did you _REALLY_ read INSTALL?" >&2
42 echo "ERROR: perhaps you forgot to run make?" >&2
43 exit 1
45 if [ ! -x src/getent ]; then
46 echo "ERROR: src/getent is not built! Did you _REALLY_ read INSTALL?" >&2
47 echo "ERROR: perhaps you forgot to run make?" >&2
48 exit 1
52 echo "*** Checking for ezcert..."
53 if [ ! -f ezcert.git/CACreateCert ]; then
54 echo "ERROR: ezcert.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
55 exit 1
59 echo "*** Checking for git..."
60 if [ ! -x "$cfg_git_bin" ]; then
61 echo "ERROR: $cfg_git_bin does not exist or is not executable" >&2
62 exit 1
64 if ! git_version="$("$cfg_git_bin" --version)"; then
65 echo "ERROR: $cfg_git_bin --version failed" >&2
66 exit 1
68 case "$git_version" in
69 "git version "*) :;;
71 echo "ERROR: '$cfg_git_bin --version' output does not start with 'git version '" >&2
72 exit 1
73 esac
76 echo "*** Setting up basedir..."
77 rm -fr "$cfg_basedir"
78 mkdir -p "$cfg_basedir"
79 cp -pR Girocco jobd taskd gitweb html jobs toolbox hooks apache.conf shlib.sh bin screen "$cfg_basedir"
80 cp -p src/can_user_push ezcert.git/CACreateCert "$cfg_basedir/bin"
81 [ -n "$cfg_httpspushurl" ] || rm -f "$cfg_basedir"/html/rootcert.html "$cfg_basedir"/html/httpspush.html
82 [ -n "$cfg_mob" ] || rm -f "$cfg_basedir"/html/mob.html
84 # Put the correct Config in place
85 [ "$GIROCCO_CONF" = "Girocco::Config" ] || cp "$(echo "$GIROCCO_CONF" | sed 's#::#/#g; s/$/.pm/')" "$cfg_basedir/Girocco/Config.pm"
88 echo "*** Preprocessing scripts..."
89 perl -I. -M$GIROCCO_CONF -i -p \
90 -e 's/(?<!")\@basedir\@/"$Girocco::Config::basedir"/g;' -e 's/(?<=")\@basedir\@/$Girocco::Config::basedir/g;' \
91 -e 's/\@reporoot\@/"$Girocco::Config::reporoot"/g;' -e 's/\@jailreporoot\@/"$Girocco::Config::jailreporoot"/g;' \
92 -e 's/\@webadmurl\@/"$Girocco::Config::webadmurl"/g;' -e 's/\@screen_acl_file\@/"$Girocco::Config::screen_acl_file"/g;' \
93 -e 's/\@mob\@/"$Girocco::Config::mob"/g;' "$cfg_basedir"/jobs/*.sh "$cfg_basedir"/jobd/*.sh \
94 "$cfg_basedir"/taskd/*.sh "$cfg_basedir"/gitweb/*.sh "$cfg_basedir"/shlib.sh "$cfg_basedir"/hooks/* \
95 "$cfg_basedir"/toolbox/* "$cfg_basedir"/bin/git-* "$cfg_basedir"/bin/create-* "$cfg_basedir"/bin/update-* \
96 "$cfg_basedir"/screen/*
99 if [ -n "$cfg_mirror" ]; then
100 echo "--- Remember to start $cfg_basedir/taskd/taskd.pl"
102 echo "--- Also remember to either start $cfg_basedir/jobd/jobd.sh, or add this"
103 echo "--- to the crontab of $cfg_mirror_user (adjust frequency on number of repos):"
104 echo "*/30 * * * * /usr/bin/nice -n 18 $cfg_basedir/jobd/jobd.sh -q --all-once"
107 echo "*** Setting up repository root..."
108 mkdir -p "$cfg_reporoot" "$cfg_reporoot-recyclebin"
109 if [ "$cfg_owning_group" ]; then
110 chgrp "$cfg_owning_group" "$cfg_reporoot" || echo "WARNING: Cannot chgrp $cfg_owning_group $cfg_reporoot"
111 chgrp "$cfg_owning_group" "$cfg_reporoot-recyclebin" || echo "WARNING: Cannot chgrp $cfg_owning_group $cfg_reporoot-recyclebin"
113 chmod 02775 "$cfg_reporoot" || echo "WARNING: Cannot chmod $cfg_reporoot properly"
114 chmod 02775 "$cfg_reporoot-recyclebin" || echo "WARNING: Cannot chmod $cfg_reporoot-recyclebin properly"
117 if [ -n "$cfg_chrooted" ]; then
118 echo "*** Setting up chroot jail for pushing..."
119 if [ "$(id -u)" -eq 0 ]; then
120 ./jailsetup.sh
121 else
122 echo "WARNING: Skipping jail setup, not root"
127 echo "*** Setting up jail configuration (project database)..."
128 [ "$(id -u)" -eq 0 ] || ./jailsetup.sh dbonly
129 mkdir -p "$cfg_chroot" "$cfg_chroot/etc"
130 touch "$cfg_chroot/etc/passwd" "$cfg_chroot/etc/group"
131 chown "$cfg_mirror_user""$owngroup" "$cfg_chroot/etc" ||
132 echo "WARNING: Cannot chown $cfg_mirror_user$owngroup $cfg_chroot/etc"
133 chown "$cfg_cgi_user""$owngroup" "$cfg_chroot/etc/passwd" "$cfg_chroot/etc/group" ||
134 echo "WARNING: Cannot chown $cfg_cgi_user$owngroup the files"
135 chmod g+w "$cfg_chroot/etc/passwd" "$cfg_chroot/etc/group" ||
136 echo "WARNING: Cannot chmod g+w the etc/passwd and/or etc/group files"
137 chmod 02775 "$cfg_chroot/etc" || echo "WARNING: Cannot chmod 02775 $cfg_chroot/etc"
140 echo "*** Setting up gitweb from git.git..."
141 if [ ! -f git.git/Makefile ]; then
142 echo "ERROR: git.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
143 exit 1
145 mkdir -p "$cfg_webroot" "$cfg_cgiroot"
146 (cd git.git && "$MAKE" --quiet gitweb && cp gitweb/gitweb.cgi "$cfg_cgiroot" \
147 && cp gitweb/static/*.png gitweb/static/*.css gitweb/static/*.js "$cfg_webroot")
150 echo "*** Setting up git-browser from git-browser.git..."
151 if [ ! -f git-browser.git/git-browser.cgi ]; then
152 echo "ERROR: git-browser.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
153 exit 1
155 mkdir -p "$cfg_webroot"/git-browser "$cfg_cgiroot"
156 (cd git-browser.git && cp git-browser.cgi "$cfg_cgiroot" \
157 && cp -r *.html *.js *.css js.lib JSON "$cfg_webroot"/git-browser)
158 ln -sf "$cfg_webroot/git-browser/JSON" "$cfg_cgiroot"
159 cat >"$cfg_cgiroot"/git-browser.conf <<EOT
160 gitbin: $cfg_git_bin
161 warehouse: $cfg_reporoot
163 cat >"$cfg_webroot"/git-browser/GitConfig.js <<EOT
164 cfg_gitweb_url="$cfg_gitweburl/"
165 cfg_browsercgi_url="$cfg_webadmurl/git-browser.cgi"
169 echo "*** Setting up darcs-fast-export from bzr-fastimport.git..."
170 if [ ! -d bzr-fastimport.git/exporters/darcs/ ]; then
171 echo "ERROR: bzr-fastimport.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
172 exit 1
174 mkdir -p "$cfg_basedir"/bin
175 cp bzr-fastimport.git/exporters/darcs/darcs-fast-export "$cfg_basedir"/bin
178 echo "*** Setting up our part of the website..."
179 mkdir -p "$cfg_webroot" "$cfg_cgiroot"
180 cp cgi/*.cgi gitweb/gitweb_config.perl "$cfg_cgiroot"
181 [ -n "$cfg_httpspushurl" ] || rm -f "$cfg_cgiroot/usercert.cgi"
182 ln -fs "$cfg_basedir"/Girocco "$cfg_cgiroot"
183 [ -z "$cfg_webreporoot" ] || { rm -f "$cfg_webreporoot" && ln -s "$cfg_reporoot" "$cfg_webreporoot"; }
184 if [ -z "$cfg_httpspushurl" ]; then
185 grep -v 'rootcert[.]html' gitweb/indextext.html > "$cfg_webroot/indextext.html"
186 else
187 cp gitweb/indextext.html "$cfg_webroot"
189 mv "$cfg_basedir"/html/*.css "$cfg_basedir"/html/*.js "$cfg_webroot"
190 cp mootools.js "$cfg_webroot"
191 cp htaccess "$cfg_webroot/.htaccess"
192 cp git-favicon.ico "$cfg_webroot/favicon.ico"
193 cp robots.txt "$cfg_webroot"
194 cat gitweb/gitweb.css >>"$cfg_webroot"/gitweb.css
197 if [ -n "$cfg_httpspushurl" ]; then
198 echo "*** Setting up SSL certificates..."
199 bits=2048
200 if [ "$cfg_rsakeylength" -gt "$bits" ] 2>/dev/null; then
201 bits="$cfg_rsakeylength"
203 mkdir -p "$cfg_certsdir"
204 [ -d "$cfg_certsdir" ]
205 wwwcertcn=
206 if [ -e "$cfg_certsdir/girocco_www_crt.pem" ]; then
207 wwwcertcn="$( \
208 openssl x509 -in "$cfg_certsdir/girocco_www_crt.pem" -noout -subject | \
209 sed -e 's,[^/]*,,' \
212 needroot=
213 [ -e "$cfg_certsdir/girocco_client_crt.pem" -a \
214 -e "$cfg_certsdir/girocco_client_key.pem" -a \
215 -e "$cfg_certsdir/girocco_www_key.pem" -a \
216 -e "$cfg_certsdir/girocco_www_crt.pem" -a "$wwwcertcn" = "/CN=$cfg_httpsdnsname" -a \
217 -e "$cfg_certsdir/girocco_root_crt.pem" ] || needroot=1
218 if [ -n "$needroot" -a ! -e "$cfg_certsdir/girocco_root_key.pem" ]; then
219 rm -f "$cfg_certsdir/girocco_root_crt.pem" "$cfg_certsdir/girocco_root_key.pem"
220 openssl genrsa -f4 -out "$cfg_certsdir/girocco_root_key.pem" $bits
221 chmod 0600 "$cfg_certsdir/girocco_root_key.pem"
222 rm -f "$cfg_certsdir/girocco_root_crt.pem"
223 echo "Created new root key"
225 if [ ! -e "$cfg_certsdir/girocco_root_crt.pem" ]; then
226 ezcert.git/CACreateCert --root --key "$cfg_certsdir/girocco_root_key.pem" \
227 --out "$cfg_certsdir/girocco_root_crt.pem" "girocco $cfg_nickname root certificate"
228 rm -f "$cfg_certsdir/girocco_www_crt.pem" "$cfg_certsdir/girocco_www_chain.pem"
229 rm -f "$cfg_certsdir/girocco_client_crt.pem" "$cfg_certsdir/girocco_client_suffix.pem"
230 rm -f "$cfg_certsdir/girocco_mob_user_crt.pem"
231 rm -f "$cfg_chroot/etc/sshcerts"/*.pem
232 echo "Created new root certificate"
234 if [ ! -e "$cfg_certsdir/girocco_www_key.pem" ]; then
235 openssl genrsa -f4 -out "$cfg_certsdir/girocco_www_key.pem" $bits
236 chmod 0600 "$cfg_certsdir/girocco_www_key.pem"
237 rm -f "$cfg_certsdir/girocco_www_crt.pem"
238 echo "Created new www key"
240 if [ ! -e "$cfg_certsdir/girocco_www_crt.pem" -o "$wwwcertcn" != "/CN=$cfg_httpsdnsname" ]; then
241 openssl rsa -in "$cfg_certsdir/girocco_www_key.pem" -pubout |
242 ezcert.git/CACreateCert --server --key "$cfg_certsdir/girocco_root_key.pem" \
243 --cert "$cfg_certsdir/girocco_root_crt.pem" \
244 --out "$cfg_certsdir/girocco_www_crt.pem" "$cfg_httpsdnsname"
245 echo "Created www certificate"
247 if [ ! -e "$cfg_certsdir/girocco_www_chain.pem" ]; then
248 cat "$cfg_certsdir/girocco_root_crt.pem" > "$cfg_certsdir/girocco_www_chain.pem"
249 echo "Created www certificate chain file"
251 if [ ! -e "$cfg_certsdir/girocco_client_key.pem" ]; then
252 openssl genrsa -f4 -out "$cfg_certsdir/girocco_client_key.pem" $bits
253 chmod 0640 "$cfg_certsdir/girocco_client_key.pem"
254 rm -f "$cfg_certsdir/girocco_client_crt.pem"
255 echo "Created new client key"
257 if [ ! -e "$cfg_certsdir/girocco_client_crt.pem" ]; then
258 openssl rsa -in "$cfg_certsdir/girocco_client_key.pem" -pubout |
259 ezcert.git/CACreateCert --subca --key "$cfg_certsdir/girocco_root_key.pem" \
260 --cert "$cfg_certsdir/girocco_root_crt.pem" \
261 --out "$cfg_certsdir/girocco_client_crt.pem" "girocco $cfg_nickname client authority"
262 rm -f "$cfg_certsdir/girocco_client_suffix.pem"
263 rm -f "$cfg_certsdir/girocco_mob_user_crt.pem"
264 rm -f "$cfg_chroot/etc/sshcerts"/*.pem
265 echo "Created client certificate"
267 if [ ! -e "$cfg_certsdir/girocco_client_suffix.pem" ]; then
268 cat "$cfg_certsdir/girocco_client_crt.pem" > "$cfg_certsdir/girocco_client_suffix.pem"
269 echo "Created client certificate suffix file"
271 cat "$cfg_rootcert" > "$cfg_webroot/${cfg_nickname}_root_cert.pem"
272 if [ -n "$cfg_mob" ]; then
273 if [ ! -e "$cfg_certsdir/girocco_mob_user_key.pem" ]; then
274 openssl genrsa -f4 -out "$cfg_certsdir/girocco_mob_user_key.pem" $bits
275 chmod 0640 "$cfg_certsdir/girocco_client_key.pem"
276 rm -f "$cfg_certsdir/girocco_mob_user_crt.pem"
277 echo "Created new mob user key"
279 if [ ! -e "$cfg_certsdir/girocco_mob_user_crt.pem" ]; then
280 openssl rsa -in "$cfg_mobuserkey" -pubout |
281 ezcert.git/CACreateCert --client --key "$cfg_clientkey" \
282 --cert "$cfg_clientcert" \
283 --out "$cfg_certsdir/girocco_mob_user_crt.pem" 'mob'
284 echo "Created mob user client certificate"
286 cat "$cfg_mobuserkey" > "$cfg_webroot/${cfg_nickname}_mob_key.pem"
287 cat "$cfg_mobusercert" "$cfg_clientcertsuffix" > "$cfg_webroot/${cfg_nickname}_mob_user.pem"
288 else
289 rm -f "$cfg_webroot/${cfg_nickname}_mob_key.pem" "$cfg_webroot/${cfg_nickname}_mob_user.pem"
291 else
292 rm -f "$cfg_webroot/${cfg_nickname}_root_cert.pem"
293 rm -f "$cfg_webroot/${cfg_nickname}_mob_key.pem" "$cfg_webroot/${cfg_nickname}_mob_user.pem"
297 echo "*** Finalizing permissions..."
298 chown -R -h "$cfg_mirror_user""$owngroup" "$cfg_basedir" "$cfg_webroot" "$cfg_cgiroot"
299 [ -z "$cfg_httpspushurl" ] || chown -R -h "$cfg_mirror_user""$owngroup" "$cfg_certsdir"